// @Ȃ̂ŁAeXg͂ĂȂB
// ͂قڃIWî̂̂܂܁B][vEzUSB̂̂gpĂ邪]ʁAp^CUSB2̂̂𗬗p
// Cypress̃ftHgGUIDȂ̂ŁAԈ@ނɃt@[EFA_E[hȂ悤ɒ
//
// Tvt@[EFAł Endpoint In=0x81/Out=0x01 gpĂB
//

#include "../StdAfx.h"
#include "DTV_OptCUsb2.h"
#include <stdlib.h>

#pragma comment(lib,"cyapi.lib")

// CUsb2 Firmware
static BYTE fw_iic[]=
#include "DTV_OptCUSB_fw.inc" /* t@C = "fw.inc" */

#define CMD_EP6IN_START		0x50	//
#define	CMD_EP6IN_STOP		0x51	//
#define	CMD_EP2OUT_START	0x52	//
#define	CMD_EP2OUT_STOP		0x53	//
#define	CMD_PORT_CFG		0x54	//addr_mask, out_pins
#define	CMD_REG_READ		0x55	//addr	(return 1byte)
#define	CMD_REG_WRITE		0x56	//addr, value
#define	CMD_PORT_READ		0x57	//(return 1byte)
#define	CMD_PORT_WRITE		0x58	//value
#define	CMD_IFCONFIG		0x59	//value
#define	CMD_MODE_IDLE		0x5a

#define	PIO_START	0x20

CDTV_OptCUsb2::CDTV_OptCUsb2() : CDTV_Base()
{
	m_pCyUSB=NULL;
	loading = false;
	_id = 0;
	bDevNodeChange = false;
	bArrived = false;
	cons_mode = true;

	CDTV_CriticalSection::InitializeCriticalSection(&m_stCS);
}

CDTV_OptCUsb2::~CDTV_OptCUsb2(void)
{
	if(IsInitialized()) Release();
	CDTV_CriticalSection::DeleteCriticalSection(&m_stCS);
}

BOOL CDTV_OptCUsb2::Initialize(char *szInitString,HWND hWnd,GUID *pGuid)
{
	if(IsInitialized()) return FALSE;
	if(!pGuid) pGuid=&CYUSBDRV_GUID;
	m_pCyUSB=new CCyUSBDevice(hWnd,*pGuid);
	if(!m_pCyUSB) return FALSE;

	loading = false;
	_id = 0;
	bDevNodeChange = false;
	bArrived = false;
	cons_mode = true;

	// bړ
	if(!fwload(0, fw_iic,(BYTE*)"FX2_FIFO"))
	{
		delete m_pCyUSB;
		m_pCyUSB=NULL;
		return FALSE;
	}

	return TRUE;
}

void CDTV_OptCUsb2::Release()
{
	DisConnect();
	if(m_pCyUSB) delete m_pCyUSB;
	m_pCyUSB=NULL;
	loading = false;
	_id = 0;
	bDevNodeChange = false;
	bArrived = false;
}

BOOL CDTV_OptCUsb2::IsInitialized()
{
	return m_pCyUSB?TRUE:FALSE;
}

DWORD CDTV_OptCUsb2::GetExtFunction()
{
	return DTV_EXTFUNC_NONE;
}

DWORD CDTV_OptCUsb2::GetDeviceCount()
{
	if(!IsInitialized()) return 0;
	return m_pCyUSB->DeviceCount();
}

BOOL CDTV_OptCUsb2::GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen)
{
	if(!IsInitialized()) return FALSE;
	if(m_pCyUSB->Open(iDevNo))
	{
		lstrcpyn(lpszDevName,m_pCyUSB->DeviceName,iBufLen);
		if(!lpszDevName[0])
		{
			lstrcpyn(lpszDevName,"?",iBufLen);
		}
		m_pCyUSB->Close();
		return TRUE;
	}
	return FALSE;
}

DWORD CDTV_OptCUsb2::GetUsbEndpointCount(int iDevNo)
{
	if(!IsInitialized()) return 0;
	if(m_pCyUSB->Open(iDevNo))
	{
		UCHAR iEpCount=m_pCyUSB->EndPointCount();
		m_pCyUSB->Close();
		return iEpCount;
	}
	return 0;
}

BOOL CDTV_OptCUsb2::GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo)
{
	if(!IsInitialized()) return FALSE;
	if(m_pCyUSB->Open(iDevNo))
	{
		BOOL bRet=FALSE;
		CCyUSBEndPoint *pCyEP=m_pCyUSB->EndPoints[iUsbEpNo];
		if(pCyEP)
		{
			if(pUsbEpInfo)
			{
				pUsbEpInfo->DscLen=pCyEP->DscLen;
				pUsbEpInfo->DscType=pCyEP->DscType;
				pUsbEpInfo->Address=pCyEP->Address;
				pUsbEpInfo->Attributes=pCyEP->Attributes;
				pUsbEpInfo->MaxPktSize=pCyEP->MaxPktSize;
				pUsbEpInfo->PktsPerFrame=pCyEP->PktsPerFrame;
				pUsbEpInfo->Interval=pCyEP->Interval;
				pUsbEpInfo->TimeOut=pCyEP->TimeOut;
				pUsbEpInfo->UsbdStatus=pCyEP->UsbdStatus;
				pUsbEpInfo->NtStatus=pCyEP->NtStatus;				
			}
			bRet=TRUE;
		}
		m_pCyUSB->Close();
		return bRet;
	}
	return FALSE;
}

BOOL CDTV_OptCUsb2::IsEndpointEffective(int iDevNo,int iUsbEpAddr)
{
	if(!IsInitialized()) return FALSE;
	BOOL bRet=FALSE;
	int i,n=GetUsbEndpointCount(iDevNo);	
	for(i=0;i<n&&!bRet;i++)
	{
		struct DTV_UsbEndpointInfo stUsbEpInfo;
		if(GetUsbEndpointInfo(iDevNo,i,&stUsbEpInfo))
		{
			if(stUsbEpInfo.Address==iUsbEpAddr) bRet=TRUE;
		}
	}
	return bRet;
}

BOOL CDTV_OptCUsb2::Connect(int iDevNo,int iInEpAddr,int iOutEpAddr)
{
	if(!IsInitialized()) return FALSE;
	if(IsConnect()) return FALSE;

	struct DTV_ThreadParam *pReq=NULL;
	struct DTV_ThreadParam *pRes=NULL;
	try
	{
		pReq=new struct DTV_ThreadParam;
		pRes=new struct DTV_ThreadParam;
		if(!pReq||!pRes) throw 101;
		ZeroMemory(pReq,sizeof(struct DTV_ThreadParam));
		ZeroMemory(pRes,sizeof(struct DTV_ThreadParam));
		pReq->pClassPtr=pRes->pClassPtr=this;
		m_stThread.hExitEvent=pReq->hExitEvent=pRes->hExitEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
		if(!m_stThread.hExitEvent) throw 102;

		struct DTV_EzUSBFX2_ReqParam *pReqParam=new struct DTV_EzUSBFX2_ReqParam;
		if(!pReqParam) throw 103;
		ZeroMemory(pReqParam,sizeof(struct DTV_EzUSBFX2_ReqParam));
		pReq->pData=pReqParam;

		// Gh|Cg
		int iInPos,iOutPos;
		int nEP=GetUsbEndpointCount(iDevNo);
		iInPos=iOutPos=-1;
		for(int i=0;i<nEP;i++)
		{
			struct DTV_UsbEndpointInfo stUsbEP;
			if(GetUsbEndpointInfo(iDevNo,i,&stUsbEP))
			{
				if(iInEpAddr==stUsbEP.Address) iInPos=i;
				if(iOutEpAddr==stUsbEP.Address) iOutPos=i;
			}
		}

		// foCXJăGh|Cg擾(In=0x81/Out=0x01)
		if(!m_pCyUSB->Open(iDevNo)) throw 301;
		if(iInPos!=-1) pReqParam->pEP_In=m_pCyUSB->EndPoints[iInPos];
		if(iOutPos!=-1) pReqParam->pEP_Out=m_pCyUSB->EndPoints[iOutPos];

		if(!pReqParam->pEP_In) throw 311;
		if(!pReqParam->pEP_Out) throw 312;

		// 񓯊L[̍쐬
		if(!MakeXferQueue())
		{
			throw 401;
		}

		// ]󋵂̃Zbg
		ClearTransferInfo();

		// t@[EFA]
//		if(!fwload(0, fw_iic,(BYTE*)"FX2_FIFO"))
//		{
//			throw 450;
//		}

		m_stThread.stRequest.hThread=CreateThread(NULL,0,XferRequestThreadEntry,pReq,CREATE_SUSPENDED,&m_stThread.stRequest.dwThreadID);
		m_stThread.stResponce.hThread=CreateThread(NULL,0,XferResponceThreadEntry,pRes,CREATE_SUSPENDED,&m_stThread.stResponce.dwThreadID);
		if(!m_stThread.stRequest.hThread||!m_stThread.stResponce.hThread)
		{
			throw 501;
		}

		LONG cmd_len=0;
		BYTE cmd[64];

		//FX2 I/O|[gݒ@@MAX2p[^ݒ  MAX2Zbg
		cmd[cmd_len++]=CMD_PORT_CFG;
		cmd[cmd_len++]=0x00;					//no addr(addr_mask)
		cmd[cmd_len++]=PIO_START;				//START(out_pins)
		cmd[cmd_len++]=CMD_MODE_IDLE;
		cmd[cmd_len++]=CMD_IFCONFIG;
		cmd[cmd_len++]=0xE3;					//slave FIFO, IFCLK=48MHz, IFCLKo,  񓯊(Async)[h
		if(pReqParam->pEP_Out->GetXferSize() < (unsigned)cmd_len)
		{
			pReqParam->pEP_Out->SetXferSize(cmd_len);
		}
		pReqParam->pEP_Out->XferData(cmd, cmd_len);
		cmd_len=0;

		// Jn
		ResumeThread(m_stThread.stRequest.hThread);
		ResumeThread(m_stThread.stResponce.hThread);

		cmd[cmd_len++]=CMD_EP6IN_START;
		cmd[cmd_len++]=CMD_PORT_WRITE;
		cmd[cmd_len++]=PIO_START;		//START=1
		if(pReqParam->pEP_Out->GetXferSize() < (unsigned)cmd_len)
		{
			pReqParam->pEP_Out->SetXferSize(cmd_len);
		}
		pReqParam->pEP_Out->XferData(cmd, cmd_len);
	}
	catch(int err_code)
	{
		DTV_CATCH_INT_ERROR_CODE(err_code);
		if(m_stThread.stRequest.hThread)
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
		if(m_stThread.stResponce.hThread)
			TerminateThread(m_stThread.stResponce.hThread,0xffffffff);
		if(m_stThread.hExitEvent)
		{
			CloseHandle(m_stThread.hExitEvent);
		}
		ZeroMemory(&m_stThread,sizeof(struct DTV_CurrentThread));

		FreeXferQueue();
		if(pReq)
		{
			if(pReq->pData) delete pReq->pData;
			delete pReq;
		}
		if(pRes)
		{
			if(pRes->pData) delete pRes->pData;
			delete pRes;
		}
		if(IsConnect())
		{
			m_pCyUSB->Close();
		}
		return FALSE;
	}
	return TRUE;
}

void CDTV_OptCUsb2::DisConnect()
{
	if(IsConnect())
	{
		SetEvent(m_stThread.hExitEvent);
		HANDLE hWait[2]={m_stThread.stRequest.hThread,m_stThread.stResponce.hThread};
		if(WaitForMultipleObjects(2,hWait,TRUE,10*1000)!=WAIT_OBJECT_0)
		{
			// ^CAEgȂ̂ŋ~
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
			TerminateThread(m_stThread.stResponce.hThread,0xffffffff);
		}
		DWORD dwExitCode;
		GetExitCodeThread(m_stThread.stRequest.hThread,&dwExitCode);
		GetExitCodeThread(m_stThread.stResponce.hThread,&dwExitCode);

		// foCX
		m_pCyUSB->Close();

		// L[J
		FreeXferQueue();

		// nh
		CloseHandle(m_stThread.stRequest.hThread);
		CloseHandle(m_stThread.stResponce.hThread);
		CloseHandle(m_stThread.hExitEvent);
		ZeroMemory(&m_stThread,sizeof(struct DTV_CurrentThread));
	}
}

BOOL CDTV_OptCUsb2::IsConnect()
{
	if(!IsInitialized()) return FALSE;
	return m_pCyUSB->IsOpen();
}

DWORD CDTV_OptCUsb2::XferRequestProc(struct DTV_ThreadParam *lpParameter)
{
	struct DTV_EzUSBFX2_ReqParam *pReqParam=(struct DTV_EzUSBFX2_ReqParam*)lpParameter->pData;

	// ]f[^TCY
	pReqParam->pEP_In->SetXferSize(DTV_OPTCUSB2_ASYNC_XFER_SIZE);

    // NGXg[v
	while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0)
	{
		struct DTV_EzUSBFX2_Request *pItem=NULL;			
		if(m_ReqWait.size()>0)
		{
			// Wait쏜
			{
				CDTV_CriticalSection sec(&m_stCS);
				pItem=m_ReqWait.front();
				m_ReqWait.pop_front();
			}
			ZeroMemory(&pItem->Overlap,sizeof(OVERLAPPED));
			pItem->Overlap.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
			pItem->pEndPoint=pReqParam->pEP_In;
			pItem->buf_len=DTV_OPTCUSB2_ASYNC_XFER_SIZE;
#ifdef _DEBUG
			ZeroMemory(pItem->buf,pItem->buf_len);
#endif
			pItem->pContext=pItem->pEndPoint->BeginDataXfer(pItem->buf,pItem->buf_len,&pItem->Overlap);
			// Busyɒǉ
			{
				CDTV_CriticalSection sec(&m_stCS);
				m_ReqBusy.push_back(pItem);
			}
		}		
		Sleep(1);
	}

	// I
	if(pReqParam)
	{
		if(pReqParam->pEP_In) pReqParam->pEP_In->Abort();
		if(pReqParam->pEP_Out) pReqParam->pEP_Out->Abort();
		delete pReqParam;
	}
	delete lpParameter;
	ExitThread(1);
	return 0;
}

DWORD CDTV_OptCUsb2::XferResponceProc(struct DTV_ThreadParam *lpParameter)
{

    // M[v
	while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0 || m_ReqBusy.size()>0)
	{
		struct DTV_EzUSBFX2_Request *pItem=NULL;
		bool bRet;			
		if(m_ReqBusy.size()>0)
		{
			// Busy̐擪擾
			{
				CDTV_CriticalSection sec(&m_stCS);
				pItem=m_ReqBusy.front();
				m_ReqBusy.pop_front();
			}

			bRet=pItem->pEndPoint->WaitForXfer(&pItem->Overlap,1000);
			if(bRet)
			{
				bRet=pItem->pEndPoint->FinishDataXfer(pItem->buf,pItem->buf_len,&pItem->Overlap,pItem->pContext);
				if(bRet)
				{
					if(pItem->buf_len>0)
					{
						m_stTransferInfo.ui64RecvTotal+=pItem->buf_len;
						DoDTVDataCallback(pItem->buf,pItem->buf_len,m_stTransferInfo.ui64RecvTotal);						
					}
					m_stTransferInfo.dwSuccess++;
				} else {
					m_stTransferInfo.dwFail++;
				}
			} else {
				m_stTransferInfo.dwFail++;
			}
			CloseHandle(pItem->Overlap.hEvent);
			pItem->Overlap.hEvent=NULL;
			// Waitɒǉ
			{
				CDTV_CriticalSection sec(&m_stCS);
				m_ReqWait.push_back(pItem);
			}
		}			

		Sleep(1);
	}

	// I
	delete lpParameter;
	ExitThread(1);
	return 0;
}

// cusb.cpp ̈ڐABقڂ̂܂
bool CDTV_OptCUsb2::fwload(u8 id, u8 *fw, u8 *string1)
{
	CCyUSBDevice*& USBDevice = m_pCyUSB;
	u8 d;
	bool find = false;
	_id = id;
	if(USBDevice->IsOpen()) USBDevice->Close();

	if(cons_mode || (loading == false)){
		for(d=0; d < USBDevice->DeviceCount(); d++)
		{
			USBDevice->Open(d);
			if(((id == 0)&&((USBDevice->BcdDevice & 0x0f00) == 0x0000))	//FX2LP:0xA0nn FX2:0x00nn
				|| (USBDevice->BcdDevice == 0xff00+id))
			{
				if((USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x8613)) find = true;
				if((USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x1004)) find = true;
			}
			if(find) break;
			USBDevice->Manufacturer[0]=0;	//OopenfoCX̏񂪎ĉŏĂ
			USBDevice->Close();
		}
		if(!find) return false;

		//Kvȃt@[[hĂ邩Ŕf
		if(string1 != NULL)
		{
			wchar_t wcs[64];
//			size_t n;
//			mbstowcs_s(&n, wcs, 64, (char *)string1, 64);
			mbstowcs(wcs,(char *)string1, 64);
			if(wcscmp(USBDevice->Manufacturer, wcs) == 0)
				return true;
		}

		//IICC[W̃[h8051Zbg
		u16 len, ofs;
		long llen;	

		//8051~
		USBDevice->ControlEndPt->ReqCode = 0xA0;
		USBDevice->ControlEndPt->Value = 0xE600;
		USBDevice->ControlEndPt->Index = 0;
		llen = 1;
		u8 tmp = 1;
		USBDevice->ControlEndPt->Write(&tmp, llen);	

		fw += 8;
		bool fw_patch = false;
		u8 *fw_patch_ptr;
		for(;;)
		{
			len = fw[0]*0x100 + fw[1];
			ofs = fw[2]*0x100 + fw[3];	

			//FW̃foCXfXNv^ VID=04B4 PID=1004 Bcd=0000oA
			//idɓKBcd(FFxx)ɏ
			const u8 des[]={0xb4, 0x04, 0x04, 0x10, 0x00, 0x00};
			u32 i,j;
			for(i = 0; i < (len & (unsigned)0x7fff); i++)
			{
				for(j = 0; j < 6; j++) if(fw[4+i+j] != des[j]) break;
				if(j >= 6)
				{
					fw[4+i+4] = id;
					fw[4+i+5] = 0xff;
					fw_patch = true;
					fw_patch_ptr = fw+4+i+4;
					break;
				}
			}
			//x_NGXg'A0'gp8051ɏ
			USBDevice->ControlEndPt->Value = ofs;
			llen = len & 0x7fff;
			USBDevice->ControlEndPt->Write(fw+4, llen);	

			if(len & 0x8000)
				break;	//ŏIiZbgj
			fw += len+4;
		}
		if(fw_patch)
		{
			fw_patch_ptr[0]=fw_patch_ptr[1]=0;
		}
		USBDevice->Close();
		loading = true;
		if(!cons_mode) return false;
		Sleep(100);
	}

	//ċÑt@[ɐڑ
	find = false;
	u32 i;
	for(i = 0; i < 40; i++)
	{
		for(d=0; d < USBDevice->DeviceCount(); d++)
		{
			USBDevice->Open(d);
			if((USBDevice->BcdDevice == 0xff00+id) && 
				(USBDevice->VendorID == 0x04B4) && (USBDevice->ProductID == 0x1004)) find = true;
			if(find) break;
			USBDevice->Close();
		}
		if(find || !cons_mode) break;
		Sleep(100);
	}
	if(!find) return false;
	loading = false;
	return true;
}

// 񓯊L[쐬
BOOL CDTV_OptCUsb2::MakeXferQueue()
{
	for(int i=0;i<DTV_OPTCUSB2_ASYNC_XFER_REQ_NUM;i++)
	{
		struct DTV_EzUSBFX2_Request *pItem=new struct DTV_EzUSBFX2_Request;
		if(!pItem)
		{
			FreeXferQueue();
			return FALSE;
		}
		ZeroMemory(pItem,sizeof(struct DTV_EzUSBFX2_Request));
		m_ReqWait.push_back(pItem);
	}
	return TRUE;
}

// 񓯊L[j
void CDTV_OptCUsb2::FreeXferQueue()
{
	struct DTV_EzUSBFX2_Request *pItem;
	// ҋ@
	while(m_ReqWait.begin()!=m_ReqWait.end())
	{
		pItem=m_ReqWait.front();
		delete pItem;
		m_ReqWait.pop_front();
	}
	// NGXg
	while(m_ReqBusy.begin()!=m_ReqBusy.end())
	{
		pItem=m_ReqBusy.front();
		if(pItem->Overlap.hEvent) CloseHandle(pItem->Overlap.hEvent);
		delete pItem;
		m_ReqBusy.pop_front();
	}

}
